"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initSDK = void 0;
const api_js_1 = require("../api/api.js");
const constants_js_1 = require("../common/constants.js");
const record_js_1 = require("./record.js");
const utils_js_1 = require("./utils.js");
const initSDK = (httpClient) => {
    class RushDB extends api_js_1.RestAPI {
        constructor(token, config) {
            var _a;
            const props = (0, utils_js_1.parseConfig)(config);
            super(token, Object.assign(Object.assign({}, props), { httpClient: (_a = props.httpClient) !== null && _a !== void 0 ? _a : httpClient }));
            this.state = {
                debug: false,
                timeout: (0, utils_js_1.validateInteger)('timeout', props.timeout, constants_js_1.DEFAULT_TIMEOUT),
                token
            };
            this.models = new Map();
            RushDB.instance = this;
        }
        static getInstance() {
            return RushDB.instance;
        }
        registerModel(model) {
            const label = model.getLabel();
            // Inject the API into the model
            model.init(this);
            this.models.set(label, model);
            return model; //as unknown as Model<T['schema']> & Omit<RestAPI, 'find'>
        }
        getModels() {
            return this.models;
        }
        getModel(label) {
            return this.models.get(label);
        }
        toInstance(record) {
            const result = new record_js_1.DBRecordInstance(record);
            result.init(this);
            return result;
        }
    }
    return RushDB;
};
exports.initSDK = initSDK;
